Clazz.declarePackage("JS");
Clazz.load(["java.util.Hashtable", "JU.P3", "$.V3"], "JS.WyckoffFinder", ["JU.JSJSONParser", "$.Measure", "$.P4", "$.PT", "$.Rdr", "$.SB", "JV.FileManager"], function(){
var c$ = Clazz.decorateAsClass(function(){
this.positions = null;
this.npos = 0;
this.ncent = 0;
this.centerings = null;
this.centeringStr = null;
Clazz.instantialize(this, arguments);}, JS, "WyckoffFinder", null);
/*LV!1824 unnec constructor*/Clazz.makeConstructor(c$, 
function(map){
if (map != null) {
var wpos = map.get("wpos");
this.positions = wpos.get("pos");
this.npos = this.positions.size();
var cent = wpos.get("cent");
if (cent != null) {
this.ncent = cent.size();
this.centeringStr =  new Array(this.ncent);
this.centerings =  new Array(this.ncent);
for (var i = this.ncent; --i >= 0; ) {
var s = cent.get(i);
this.centeringStr[i] = s;
this.centerings[i] = JS.WyckoffFinder.toPoint(s);
}
}}}, "java.util.Map");
Clazz.defineMethod(c$, "getWyckoffFinder", 
function(vwr, sgname){
var helper = JS.WyckoffFinder.helpers.get(sgname);
if (helper == null) {
var itno = JU.PT.parseInt(JU.PT.split(sgname, ":")[0]);
if (itno >= 1 && itno <= 230) {
var resource = this.getResource(vwr, "ita_" + itno + ".json");
if (resource != null) {
var its = resource.get("its");
if (its != null) {
for (var i = its.size(); --i >= 0; ) {
var map = its.get(i);
if (sgname.equals(map.get("itaFull"))) {
JS.WyckoffFinder.helpers.put(sgname, helper =  new JS.WyckoffFinder(map));
return helper;
}}
}}}}if (helper == null) {
if (JS.WyckoffFinder.nullHelper == null) JS.WyckoffFinder.nullHelper =  new JS.WyckoffFinder(null);
JS.WyckoffFinder.helpers.put(sgname, JS.WyckoffFinder.nullHelper);
}return helper;
}, "JV.Viewer,~S");
Clazz.defineMethod(c$, "getWyckoffPosition", 
function(uc, p, returnType){
switch (returnType) {
case 42:
var sb =  new JU.SB();
this.getCenteringStr(-1, sb);
for (var i = this.npos; --i >= 0; ) {
var map = this.positions.get(i);
var label = map.get("label");
sb.appendC('\n').append(label);
if (i == 0) {
sb.append(" (x,y,z)");
} else {
JS.WyckoffFinder.getList(map.get("coord"), label, sb);
}}
return sb.toString();
case -1:
case -2:
case -3:
for (var i = this.positions.size(); --i >= 0; ) {
var map = this.positions.get(i);
var label = map.get("label");
if (i == 0) {
switch (returnType) {
case -1:
return label;
case -2:
return "(x,y,z)";
case -3:
return map.get("label") + "  (x,y,z)";
}
}var coords = map.get("coord");
for (var c = 0, n = coords.size(); c < n; c++) {
var coord = JS.WyckoffFinder.getWyckoffCoord(coords, c, label);
if (coord.contains(uc, p, this)) {
switch (returnType) {
case -1:
return label;
case -2:
return coord.asString(null, true).toString();
case -3:
var sbc =  new JU.SB();
sbc.append(label).appendC(' ');
this.getCenteringStr(-1, sbc).appendC(' ');
JS.WyckoffFinder.getList(coords, label, sbc);
return sbc.toString();
}
}}
}
break;
default:
var letter = "" + String.fromCharCode(returnType);
for (var i = this.npos; --i >= 0; ) {
var map = this.positions.get(i);
if (map.get("label").equals(letter)) {
return (i == 0 ? "(x,y,z)" : JS.WyckoffFinder.getList(map.get("coord"), letter, null).toString());
}}
break;
}
return "?";
}, "JS.UnitCell,JU.P3,~N");
Clazz.defineMethod(c$, "getCenteringStr", 
function(n, sb){
if (sb == null) sb =  new JU.SB();
if (this.ncent == 0) return sb;
if (n >= 0) {
sb.appendC('+');
return JS.WyckoffFinder.wrap(this.centeringStr[n], sb);
}for (var i = 0; i < this.ncent; i++) {
sb.appendC('+');
JS.WyckoffFinder.wrap(this.centeringStr[i], sb);
}
return sb;
}, "~N,JU.SB");
c$.wrap = Clazz.defineMethod(c$, "wrap", 
function(xyz, sb){
return sb.appendC('(').append(xyz).appendC(')');
}, "~S,JU.SB");
c$.getList = Clazz.defineMethod(c$, "getList", 
function(coords, letter, sb){
if (sb == null) sb =  new JU.SB();
for (var c = 0, n = coords.size(); c < n; c++) {
var coord = JS.WyckoffFinder.getWyckoffCoord(coords, c, letter);
sb.append(" ");
coord.asString(sb, false);
}
return sb;
}, "JU.Lst,~S,JU.SB");
Clazz.defineMethod(c$, "findPositionFor", 
function(p, letter){
if (this.positions == null) return null;
for (var i = this.npos; --i >= 0; ) {
var map = this.positions.get(i);
if (map.get("label").equals(letter)) {
var coords = map.get("coord");
if (coords != null) JS.WyckoffFinder.getWyckoffCoord(coords, 0, letter).set(p);
return p;
}}
return null;
}, "JU.P3,~S");
c$.getWyckoffCoord = Clazz.defineMethod(c$, "getWyckoffCoord", 
function(coords, c, label){
var coord = coords.get(c);
if ((typeof(coord)=='string')) {
coords.set(c, coord =  new JS.WyckoffFinder.WyckoffPos(coord, label));
}return coord;
}, "JU.Lst,~N,~S");
Clazz.defineMethod(c$, "getResource", 
function(vwr, resource){
try {
var r = JV.FileManager.getBufferedReaderForResource(vwr, this, "JS/", "sg/json/" + resource);
var data =  new Array(1);
if (JU.Rdr.readAllAsString(r, 2147483647, false, data, 0)) {
return  new JU.JSJSONParser().parse(data[0], true);
}} catch (e) {
System.err.println(e.getMessage());
}
return null;
}, "JV.Viewer,~S");
c$.toPoint = Clazz.defineMethod(c$, "toPoint", 
function(xyz){
var s = JU.PT.split(xyz, ",");
return JU.P3.new3(JU.PT.parseFloatFraction(s[0]), JU.PT.parseFloatFraction(s[1]), JU.PT.parseFloatFraction(s[2]));
}, "~S");
/*if3*/;(function(){
var c$ = Clazz.decorateAsClass(function(){
this.point = null;
this.line = null;
this.plane = null;
this.type = 0;
this.label = null;
this.xyz = null;
this.thisCentering = "";
this.parts = null;
Clazz.instantialize(this, arguments);}, JS.WyckoffFinder, "WyckoffPos", null);
Clazz.prepareFields (c$, function(){
this.parts =  new Array(3);
});
Clazz.makeConstructor(c$, 
function(xyz, label){
this.xyz = xyz;
this.label = label;
this.create(xyz);
}, "~S,~S");
Clazz.defineMethod(c$, "create", 
function(p){
var xyz = JU.PT.split(p, ",");
var nxyz = 0;
for (var i = 0; i < 3; i++) {
if (xyz[i].indexOf('x') >= 0) {
nxyz |= 1;
}if (xyz[i].indexOf('y') >= 0) {
nxyz |= 2;
}if (xyz[i].indexOf('z') >= 0) {
nxyz |= 4;
}}
switch (nxyz) {
case 0:
this.type = 1;
this.point = JS.WyckoffFinder.toPoint(p);
break;
case 1:
case 2:
case 4:
this.type = 2;
this.ptFor(0.19, 0.53, 0.71, JS.WyckoffFinder.WyckoffPos.p1);
this.ptFor(0.51, 0.27, 0.64, JS.WyckoffFinder.WyckoffPos.p2);
JS.WyckoffFinder.WyckoffPos.p2.sub2(JS.WyckoffFinder.WyckoffPos.p2, JS.WyckoffFinder.WyckoffPos.p1);
JS.WyckoffFinder.WyckoffPos.p2.normalize();
this.point = JU.P3.newP(JS.WyckoffFinder.WyckoffPos.p1);
this.line = JU.V3.newV(JS.WyckoffFinder.WyckoffPos.p2);
break;
case 3:
case 5:
case 6:
this.type = 3;
this.ptFor(0.19, 0.51, 0.73, JS.WyckoffFinder.WyckoffPos.p1);
this.ptFor(0.23, 0.47, 0.86, JS.WyckoffFinder.WyckoffPos.p2);
this.ptFor(0.1, 0.2, 0.3, JS.WyckoffFinder.WyckoffPos.p3);
this.plane = JU.Measure.getPlaneThroughPoints(JS.WyckoffFinder.WyckoffPos.p1, JS.WyckoffFinder.WyckoffPos.p2, JS.WyckoffFinder.WyckoffPos.p3, null, null,  new JU.P4());
break;
case 7:
break;
}
}, "~S");
Clazz.defineMethod(c$, "ptFor", 
function(x, y, z, p){
var v = JU.PT.split(this.xyz, ",");
if (this.parts != null) {
this.parts[0] = this.getParts(v[0]);
this.parts[1] = this.getParts(v[1]);
this.parts[2] = this.getParts(v[2]);
}p.set(JS.WyckoffFinder.WyckoffPos.decodeXYZ(this.parts[0], x, y, z), JS.WyckoffFinder.WyckoffPos.decodeXYZ(this.parts[1], x, y, z), JS.WyckoffFinder.WyckoffPos.decodeXYZ(this.parts[2], x, y, z));
}, "~N,~N,~N,JU.T3");
Clazz.defineMethod(c$, "getParts", 
function(s){
s = JU.PT.rep(s, "-", "+-");
s = JU.PT.rep(s, "x", "*x");
s = JU.PT.rep(s, "y", "*y");
s = JU.PT.rep(s, "z", "*z");
s = JU.PT.rep(s, "-*", "-");
s = JU.PT.rep(s, "+*", "+");
return JU.PT.split(s, "+");
}, "~S");
c$.decodeXYZ = Clazz.defineMethod(c$, "decodeXYZ", 
function(parts, x, y, z){
var r = 0;
for (var p = parts.length; --p >= 0; ) {
var s = parts[p];
if (s.length == 0) continue;
if (s.indexOf('.') >= 0) {
r += JU.PT.parseFloat(s);
continue;
}var v = 0;
var f2 = 0;
var i0 = 0;
var f = 1;
switch ((s.charAt(0)).charCodeAt(0)) {
case 45:
f = -1;
case 42:
i0++;
break;
}
for (var i = s.length; --i >= i0; ) {
var c = s.charAt(i);
switch ((c).charCodeAt(0)) {
case 120:
v = x;
break;
case 121:
v = y;
break;
case 122:
v = z;
break;
case 47:
f2 = 1;
v = 1 / v;
case 42:
f *= v;
v = 0;
break;
default:
var u = "0123456789".indexOf(c);
if (u < 0) System.err.println("WH ????");
if (v == 0) {
v = u;
} else {
f2 = (f2 == 0 ? 10 : f2 * 10);
v += f2 * u;
}break;
}
}
r += f * v;
}
return r;
}, "~A,~N,~N,~N");
Clazz.defineMethod(c$, "contains", 
function(uc, p, w){
var slop = uc.getPrecision();
this.thisCentering = null;
if (this.containsPt(uc, p, slop, true)) return true;
if (w.centerings != null) for (var i = w.centerings.length; --i >= 0; ) {
JS.WyckoffFinder.WyckoffPos.pc.add2(p, w.centerings[i]);
uc.unitize(JS.WyckoffFinder.WyckoffPos.pc);
if (this.containsPt(uc, JS.WyckoffFinder.WyckoffPos.pc, slop, true)) {
this.thisCentering = w.centeringStr[i];
return true;
}}
return false;
}, "JS.UnitCell,JU.P3,JS.WyckoffFinder");
Clazz.defineMethod(c$, "containsPt", 
function(uc, p, slop, doLatticeCheck){
if (doLatticeCheck) {
for (var i = -2; i < 3; i++) {
for (var j = -2; j < 3; j++) {
for (var k = -2; k < 3; k++) {
JS.WyckoffFinder.WyckoffPos.p3.set(i, j, k);
JS.WyckoffFinder.WyckoffPos.p3.add(p);
if (this.containsPt(uc, JS.WyckoffFinder.WyckoffPos.p3, slop, false)) {
System.out.println(this.label + " " + this.xyz + " found for " + i + " " + j + " " + k);
return true;
}}
}
}
return false;
}var d = 1;
switch (this.type) {
case 1:
d = this.point.distance(p);
JS.WyckoffFinder.WyckoffPos.p1.setT(this.point);
break;
case 2:
JS.WyckoffFinder.WyckoffPos.p1.setT(p);
JU.Measure.projectOntoAxis(JS.WyckoffFinder.WyckoffPos.p1, this.point, this.line, JS.WyckoffFinder.WyckoffPos.vt);
JS.WyckoffFinder.WyckoffPos.p2.sub2(JS.WyckoffFinder.WyckoffPos.p1, p);
d = JS.WyckoffFinder.WyckoffPos.p1.distance(p);
break;
case 3:
JS.WyckoffFinder.WyckoffPos.p1.setT(p);
d = Math.abs(JU.Measure.getPlaneProjection(JS.WyckoffFinder.WyckoffPos.p1, this.plane, JS.WyckoffFinder.WyckoffPos.vt, JS.WyckoffFinder.WyckoffPos.vt));
break;
}
return d < slop;
}, "JS.UnitCell,JU.P3,~N,~B");
Clazz.defineMethod(c$, "set", 
function(p){
switch (this.type) {
case 1:
p.setT(this.point);
break;
case 2:
JU.Measure.projectOntoAxis(p, this.point, this.line, JS.WyckoffFinder.WyckoffPos.vt);
break;
case 3:
JU.Measure.getPlaneProjection(p, this.plane, JS.WyckoffFinder.WyckoffPos.vt, JS.WyckoffFinder.WyckoffPos.vt);
p.setT(JS.WyckoffFinder.WyckoffPos.vt);
break;
}
}, "JU.P3");
Clazz.defineMethod(c$, "asString", 
function(sb, withCentering){
if (sb == null) sb =  new JU.SB();
JS.WyckoffFinder.wrap(this.xyz, sb);
if (withCentering && this.thisCentering != null) {
sb.appendC('+');
JS.WyckoffFinder.wrap(this.thisCentering, sb);
}return sb;
}, "JU.SB,~B");
Clazz.overrideMethod(c$, "toString", 
function(){
return this.asString(null, false).toString();
});
c$.p1 =  new JU.P3();
c$.p2 =  new JU.P3();
c$.p3 =  new JU.P3();
c$.pc =  new JU.P3();
c$.vt =  new JU.V3();
/*eoif3*/})();
c$.helpers =  new java.util.Hashtable();
c$.nullHelper = null;
});
;//5.0.1-v2 Thu Jan 18 21:03:27 CST 2024
